@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION
SETLOCAL ENABLEEXTENSIONS
SET neededfiles=dsfo.exe dsfi.exe
FOR %%A IN (%neededfiles%) DO IF NOT EXIST %%A ECHO Missing file: %%A& GOTO :ERROR1
IF %2.==. (SET INTERACTIVE=1) ELSE (SET INTERACTIVE=0)
SET /A comline=0
FOR %%A IN (CREATE VIEW COPY EDIT UPATCH WRITE HELP) DO IF /I %%A.==%1. SET /A comline=!comline!+1
IF NOT %comline%==1 GOTO :Syntax
GOTO :MBR%1

:Syntax
CLS
:: Original filename mbr0toX.cmd
ECHO %~nx0 batch file to manage MBR's Release 0.01 ALPHA 12th  Feb. 2008
ECHO by jaclaz, this file is licensed under my "CAREWARE" license:
ECHO http://home.graffiti.net/jaclaz:graffiti.net/careware.html
ECHO.
ECHO General syntax is %~nx0 COMMAND [parameters], commands are:
ECHO.
ECHO COPY source targetfile length Copies length bytes from source, saving it as targetfile
ECHO WRITE source target [/F] Writes a MBR file to target
ECHO HELP command		 Displays help for the given command
ECHO.
ECHO Notes:
ECHO [source] can be a file or a drive number, [sourcefile] must be a <=512 bytes file
ECHO [target] can be a file or a drive number, [targetfile] must be a NEW file
ECHO.
ECHO If any non-optional parameter is missing, it will enter interactive mode.
GOTO :EOF

:MBRCOPY
SHIFT
IF %INTERACTIVE%.==1. GOTO :MBRCOPYI
IF NOT DEFINED Source SET Source=%1
IF %Source% Geq 0 IF %Source% Leq 9 SET Source=\\.\PHYSICALDRIVE%Source%
SHIFT
IF NOT DEFINED Target SET Target=%1
IF NOT DEFINED Target GOTO :MBRCOPYI
SHIFT
IF NOT DEFINED Length SET Length=%1
IF NOT DEFINED Length GOTO :MBRCOPYI
IF %Length% GTR 512 GOTO :Error
SET /A Offset=0
ECHO Creating a MBR from %Source% with dsfo.exe:
ECHO dsfo %Source% %Offset% %Length% %Target%
IF EXIST %Target% del %Target%
dsfo %Source% %Offset% %Length% %Target%
SET RSource=%Source%  Temporary file: %Target%
Set Source=%Target%
GOTO :EOF

:MBRCOPYI
CLS
IF NOT DEFINED Source SET /P Source= Please enter a Source for the MBR: 
IF NOT DEFINED Source GOTO :MBRCOPYI
SET Target=
SET /P Target=Please enter a destination filename for the MBR:
IF NOT DEFINED Target GOTO :MBRCOPYI
SET Length=
SET /P length=Please enter a length in bytes to be copied:
IF NOT DEFINED Length GOTO :MBRCOPYI
ECHO %Source% %Offset% %Length% %Target%
SET Overwrite=NO
IF EXIST %Target% SET /P Overwrite=File %Target% already exists, input YES to overwrite: 
IF NOT EXIST %Target% SET Overwrite=YES
IF /I NOT %Overwrite%==YES ECHO File %Target% NOT overwritten&PAUSE&GOTO :EOF
SET INTERACTIVE=0
GOTO :MBRCOPY
GOTO :EOF


:MBRWRITE
SHIFT
IF %INTERACTIVE%.==1. GOTO :MBRwriteI
CALL :CheckMBRsize %1 %2 %3
IF NOT DEFINED Target GOTO :Error
dsfi %Target% 0 %Size% %Source%
GOTO :EOF

:MBRWRITEI
CLS
IF NOT DEFINED Source SET /P Source=Please enter Source file: 
IF NOT EXIST %Source% ECHO File Not Found!&PAUSE&GOTO :MBRwriteI
IF NOT DEFINED Target SET /A Target=0
SET /P Target=Please enter target (drive number or file): 
FOR %%A in (0 1 2 3 4 5 6 7 8 9) DO IF %%A.==%Target%. SET /A Target=%Target%
IF %Target%==0 (
SET /P Force=You asked to overwrite MBR on \\.\PHYSICALDRIVE0, Enter YES to confirm: 
SET F
IF /I !Force!.==YES. (
SET Force=/F
) ELSE (
ECHO MBR on \\.\PHYSICALDRIVE0 was NOT overwritten!
PAUSE
GOTO :EOF
)
ECHO OFF
)
CALL :CheckMBRsize %Source% %Target% %Force%
IF NOT DEFINED Target GOTO :Error
dsfi %Target% 0 %Size% %Source%
GOTO :EOF

:CheckMBRsize
IF NOT EXIST %~dpnx1 GOTO :Error
IF %2.==. GOTO :Error
IF %~z1 GTR 512 GOTO :Error
SET Source=%~dpnx1
SET Size=%~z1
IF /I %3.==/F. (SET MinDrive=0) ELSE (SET MinDrive=1)
IF %2 Geq %MinDrive% IF %2 Leq 9 (SET Target=\\.\PHYSICALDRIVE%2) ELSE (SET Target=%2)
set target
pause
GOTO :EOF


:MBRHELP
SET HELP=%2
IF NOT DEFINED HELP SET HELP=ALL&CALL :MBRHELPI
ECHO %1 %2
PAUSE
SET /A comline=0
FOR %%A IN (CREATE VIEW COPY EDIT UPATCH WRITE HELP ALL) DO IF /I %%A.==%HELP%. SET /A comline=!comline!+1
IF NOT %comline%==1 GOTO :ERROR
GOTO :MBRHELP%HELP%

:MBRHELPI
CLS
ECHO Input the command you need help on or press [ENTER] to view ALL commands help:
ECHO Available commands: COPY WRITE HELP
SET HELP
SET /P HELP=
GOTO :EOF

:MBRHELPALL
FOR %%A IN (COPY WRITE HELP) DO CALL :MBRHELP%%A
GOTO :EOF


:MBRHELPCOPY
CLS
ECHO COPY  [source] [destfile] [length] 	Creates a file from source 
ECHO						of given [length] and saves it to a file
ECHO.
ECHO Source can be either a MBR file or a drive number.
ECHO What the command does is to simply extract first [length]
ECHO bytes from [source], so it can also be any file in 
ECHO which the first [length] bytes are a Master Boot Record.
ECHO [length] must be equal or less than 512 bytes
ECHO.
ECHO Drive numbers begin with 0.
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 COPY C:\MBRBATCHDIR\my_MBR.mbr C:\ANOTHERDIR\SomeMBR.bin 446
ECHO %~nx0 COPY 0 my_MBR.mbr 446
PAUSE
GOTO :EOF


:MBRHELPWRITE
CLS
ECHO %~nx0 WRITE [source] [destdrive] [/F] Writes a MBR file to destdrive
ECHO.
ECHO Simply writes the source file to destdrive.
ECHO For security reasons, if you input first disk, i.e. 0, you NEED to add
ECHO the parameter /F (for FORCE) when %~nx0 is invoked from command line or
ECHO from amother batch.
ECHO In interactive mode, a confirmation will be asked anyway.
ECHO [source] size must be equal or less than 512 bytes
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 WRITE C:\A_directory\my_MBR.mbr 1
ECHO will write contents of file my_MBR.mbr (512 bytes) to \\.\PHYSICALDRIVE1
ECHO %~nx0 WRITE C:\A_directory\my_MBR.mbr 0 /F
ECHO will write contents of file my_MBR.mbr (512 bytes) to \\.\PHYSICALDRIVE0
PAUSE
GOTO :EOF

:MBRHELPHELP
CLS
ECHO %~nx0 HELP		Shows the HELP info
ECHO.
ECHO Basically, if you need help to use the HELP command,
ECHO I am afraid you won't be able to appreciate the use
ECHO of this batch file. :(
ECHO.
ECHO Try the HELP command with some other command, it might
ECHO be more useful than this lame notice. ;)
PAUSE
GOTO :EOF

:error
ECHO An error has occurred
GOTO :EOF

:error1
ECHO Please add the missing file %1 in the same directory where %~nx0 is
GOTO :EOF