REM mbrbatch.cmd Modded From mbrbatch002.zip of jaclazz
@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION
SETLOCAL ENABLEEXTENSIONS
SET neededfiles=gsar.exe dsfo.exe dsfi.exe dumphex.exe
FOR %%A IN (%neededfiles%) DO IF NOT EXIST %%A ECHO Missing file: %%A& GOTO :ERROR1
IF %2.==. (SET INTERACTIVE=1) ELSE (SET INTERACTIVE=0)
SET /A comline=0
FOR %%A IN (CREATE VIEW COPY EDIT UPATCH WRITE HELP) DO IF /I %%A.==%1. SET /A comline=!comline!+1
IF NOT %comline%==1 GOTO :Syntax
GOTO :MBR%1

:Syntax
CLS
ECHO %~nx0 batch file to manage MBR's Release 0.02 ALPHA 1st  Oct. 2007
ECHO by jaclaz, this file is licensed under my "CAREWARE" license:
ECHO http://home.graffiti.net/jaclaz:graffiti.net/careware.html
ECHO.
ECHO General syntax is %~nx0 COMMAND [parameters], commands are:
ECHO.
ECHO CREATE targetfile	 Creates MBR from a 2K/XP file saving it as targetfile
ECHO VIEW source		 Shows partition entries in source MBR
ECHO COPY source targetfile	 Copies a MBR from source, saving it as targetfile
ECHO EDIT sourcefile [params] Edits one partition entry in MBR file
ECHO UPATCH sourcefile	 Patches sourcefile with "HP" USB/int13 modification
ECHO				 (sourcefile must contain 2K/XP MBR code)
ECHO WRITE source target [/F] Writes a MBR file to target
ECHO MKIMG filesize		 Creates an image of given size, complete of MBR 
ECHO				 (NOT YET AVAILABLE)
ECHO HELP command		 Displays help for the given command
ECHO.
ECHO Notes:
ECHO [source] can be a file or a drive number, [sourcefile] must be a 512 bytes file
ECHO [target] can be a file or a drive number, [targetfile] must be a NEW file
ECHO.
ECHO If any non-optional parameter is missing, it will enter interactive mode.
GOTO :EOF

:MBRCREATE
IF %INTERACTIVE%.==1. CALL :MBRCREATEI
SET gsarstring=gsar -b -s:x33:xC0:x8E:xD0:xBC:x00:x7C:xFB:x50
SET Sysfile=%SystemRoot%\System32\dmadmin.exe
if exist .\dmadmin.exe goto dmadimexeexist
if exist .\dmadmin.ex_ goto dmadimexexist
if exist %SystemRoot%\System32\dmadmin.exe copy %SystemRoot%\System32\dmadmin.exe .\
goto dmadimexeexist
:dmadimexexist
expand dmadmin.ex_ .\dmadmin.exe
:dmadimexeexist
if not exist dmadmin.exe goto dmadminnotexist
goto dmadmincontinue
:dmadminnotexist
cls
ECHO dmadmin.exe or dmadmin.ex_ not found press any key to exit
pause
exit
:dmadmincontinue
set Sysfile=%~dp0dmadmin.exe
REM SET Sysfile=%SystemRoot%\System32\spcmdcon.sys
REM SET Sysfile=%SystemRoot%\ServicePackFiles\I386\setupdd.sys
FOR /F "tokens=3 delims=:" %%A IN ('%gsarstring% %Sysfile%^|FIND "%Sysfile%"^| FIND /V "match found"') DO SET /A Offset=%%A
SET /A Offset=%Offset%
Set /A Length=512
SET Target=%2
ECHO Creating a MBR from %Sysfile% with dsfo.exe:
REM IF EXIST %Target% del %Target%
dsfo %Sysfile% %Offset% %Length% %Target%
GOTO :EOF

:MBRCREATEI
CLS
SET Target=
SET /P Target=Please enter a destination filename for the MBR:
SET Overwrite=NO
IF EXIST %Target% SET /P Overwrite=File %Target% already exists, input YES to overwrite: 
IF /I NOT %Overwrite%==YES ECHO File %Target% NOT overwritten&PAUSE&GOTO :EOF
SET INTERACTIVE=0
GOTO :EOF

:MBRVIEW
SHIFT
SET Source=%1

:MBRVIEWI
IF NOT DEFINED Source SET /P Source= Please enter a Source for the MBR: 
IF NOT DEFINED Source GOTO :MBRCOPYI
IF %Source% Geq 0 IF %Source% Leq 9 (SET Source=\\.\PHYSICALDRIVE%Source%) ELSE (GOTO :MBRFILEVIEW)
IF NOT DEFINED Target SET Target=MBRTEMP.$$$
SET /A Offset=0
Set /A Length=512
ECHO Creating a MBR from %Source% with dsfo.exe:
IF EXIST %Target% del %Target%
dsfo %Source% %Offset% %Length% %Target%
SET RSource=%Source%  Temporary file: %Target%
Set Source=%Target%

:MBRFILEVIEW
ECHO Dumping partition entries with DumpHex Version 1.0.1 
ECHO Copyright (c) 2003 Robert Bachmann
SET /A Length=16
SET /A VPartnum=1
SET /A Offset=0x1BE

:LoopEntries
SET newline=
REM DUMMYSPACE A B C D E F G H  I  J  K  L  M  N  O  P
FOR /F "tokens=2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17 delims=: " %%A IN ('dumphex /S%Offset% /L%Length% /w16 /nc %Source% 2^>nul') DO (
SET VActive=%%A
SET VPartType=%%E
SET /A VBHd=0x%%B
SET /A VBSecCyl=0x%%C%%D
SET /A VEHd=0x%%F
SET /A VESecCyl=0x%%G%%H
SET /A VStartLBA=0x%%L%%K%%J%%I
SET /A VSectorsLBA=0x%%P%%O%%N%%M
)
SET Powers=32768 16384 8192 4096 2048 1024 512 256 128 64 32 16 8 4 2 1

CALL :DEC2BIN %VBSecCyl%
SET VBCyl=%BINnum:~0,2%%BINnum:~8,8%
SET VBSec=%BINnum:~2,6%

CALL :DEC2BIN %VESecCyl%
SET VECyl=%BINnum:~0,2%%BINnum:~8,8%
SET VESec=%BINnum:~2,6%

SET Powers=512 256 128 64 32 16 8 4 2 1

CALL :BIN2DEC %VBCyl% 10
SET VBCyl=%DECnum%

CALL :BIN2DEC %VECyl% 10
SET VECyl=%DECnum%

SET Powers=32 16 8 4 2 1

CALL :BIN2DEC %VBSec% 6
SET VBSec=%DECnum%

CALL :BIN2DEC %VESec% 6
SET VESec=%DECnum%

FOR %%A IN ( 
VPartnum.6
VParttype.11
VActive.16
VBCyl.23
VBHd.27
VBSec.32
VECyl.39
VEHd.43
VESec.48
VStartLBA.60
VSectorsLBA.74
) DO (
CALL :adddata newline %%~nA %%~xA
)
IF NOT DEFINED Target SET RSource=%Source%
For %%A IN (1 2 3 4) DO IF NOT DEFINED Line%%A SET LINE%%A=                                                               
SET Linea=Source:%RSource%
SET Lineb=Ŀ
SET Linec=Part TypeBoot  Begin   CHS     End   CHS    LBA Start  LBA Sectors 
SET Lined=  #           BCyl BHdBSec ECyl EHdESec                        
SET Linee=Ĵ
SET Line%Vpartnum%=%newline%
SET Linef=Ĵ
SET Lineg=
CLS
For %%A IN (a b c d e 1 f 2 f 3 f 4 g) DO ECHO !Line%%A!
IF NOT %VPartnum%==4 (
SET /A VPartnum=%VPartnum%+1
SET /A Offset=%Offset%+16
GOTO :LoopEntries
)
IF EXIST MBRTEMP.$$$ DEL MBRTEMP.$$$
GOTO :EOF

:DEC2BIN
SET BINnum=
SET DECnum=%1
SET /A Val32768=%DECnum% / 32768
SET /A Mod32768=%DECnum% %% 32768
FOR %%A in (%Powers%) DO CALL:BINcalc %%A
FOR %%A in (%Powers%) DO SET BINnum=!BINnum!!Val%%A!
GOTO :EOF

:BINcalc
IF %1==1 GOTO :EOF
SET /A Div=%1 /2
SET /A Val%Div%=!Mod%1! / %Div%
SET /A Mod%Div%=!Mod%1! %% %Div%
GOTO :EOF

:BIN2DEC
SET DECnum=
SET BINnum=%1
SET BINLength=%2
Set Counter=0
FOR %%A IN (%Powers%) DO (
CALL :DECcalc %%A
SET /A Counter=!Counter!+1
)
FOR %%A IN (%Powers%) DO SET /A DECnum=!DECnum!+!Digit%%A!*%%A
GOTO :EOF

:DECcalc
SET digit%1=!BINNum:~%Counter%,1!
IF %Counter%==%BINLength% GOTO :EOF
GOTO :EOF

:DEC2hex
SET DECnum=%1
SET Numdig=%2
SET HEXnum=
SET Powers=268435456 16777216 1048576 65536 4096 256 16 1
::=======================================================
::| WARNING! Limit is 2147483647 i.e. 7FFFFFF  WARNING! |
::=======================================================
SET /A Limit=%DECnum%/16
IF %Limit% LSS 0 ECHO Out of Range &GOTO :EOF
SET /A Val268435456=%DECnum% / 268435456
SET /A Mod268435456=%DECnum% %% 268435456
FOR %%A in (%Powers%) DO CALL:HEXcalc %%A
FOR %%A in (%Powers%) DO CALL:HEXchar %%A
FOR %%A in (%Powers%) DO SET Hexnum=!Hexnum!!Val%%A!

SET /A Length=8
SET HexnumF=%Hexnum%
CALL :RemoveLead

GOTO :EOF

:RemoveLead
Set/A Length=%Length%-2
IF %HexnumF:~0,2%==00 set HEXnumF=!HexnumF:~-%Length%!&GOTO :RemoveLead
SET HexnumF=!Hexnum:~-%NumDig%!
SET Hexnum=%HexnumF:~6,2%%HexnumF:~4,2%%HexnumF:~2,2%%HexnumF:~0,2%
GOTO :EOF

:HEXcalc
IF %1==1 GOTO :EOF
SET /A Div=%1 /16
SET /A Val%Div%=!Mod%1! / %Div%
SET /A Mod%Div%=!Mod%1! %% %Div%
GOTO :EOF

:HEXchar
IF !Val%1!==10 SET Val%1=A
IF !Val%1!==11 SET Val%1=B
IF !Val%1!==12 SET Val%1=C
IF !Val%1!==13 SET Val%1=D
IF !Val%1!==14 SET Val%1=E
IF !Val%1!==15 SET Val%1=F
GOTO :EOF

:MBRCOPY
SHIFT
IF %INTERACTIVE%.==1. GOTO :MBRCOPYI
IF NOT DEFINED Source SET Source=%1
IF %Source% Geq 0 IF %Source% Leq 9 SET Source=\\.\PHYSICALDRIVE%Source%
SHIFT
IF NOT DEFINED Target SET Target=%1
IF NOT DEFINED Target GOTO :MBRCOPYI
SET /A Offset=0
Set /A Length=512
ECHO Creating a MBR from %Source% with dsfo.exe:
ECHO dsfo %Source% %Offset% %Length% %Target%
IF EXIST %Target% del %Target%
dsfo %Source% %Offset% %Length% %Target%
SET RSource=%Source%  Temporary file: %Target%
Set Source=%Target%
GOTO :EOF

:MBRCOPYI
CLS
IF NOT DEFINED Source SET /P Source= Please enter a Source for the MBR: 
IF NOT DEFINED Source GOTO :MBRCOPYI
SET Target=
SET /P Target=Please enter a destination filename for the MBR:
IF NOT DEFINED Target GOTO :MBRCOPYI
ECHO %Source% %Offset% %Length% %Target%
SET Overwrite=NO
IF EXIST %Target% SET /P Overwrite=File %Target% already exists, input YES to overwrite: 
IF NOT EXIST %Target% SET Overwrite=YES
IF /I NOT %Overwrite%==YES ECHO File %Target% NOT overwritten&PAUSE&GOTO :EOF
SET INTERACTIVE=0
GOTO :MBRCOPY
GOTO :EOF

:MBRUPATCH
SHIFT
IF %1.==. GOTO :ERROR
SET gsarstring=gsar -o -s:xB8:x01:x02 -r:xEB:x1A:x90
SET Confirm=NO
SET /P Confirm=Are you sure you want to patch file? (You need to type YES)
IF /I %Confirm%==YES %gsarstring% %1

GOTO :EOF

:MBRWRITE
SHIFT
IF %INTERACTIVE%.==1. GOTO :MBRwriteI
CALL :CheckMBRsize %1 %2 %3
IF NOT DEFINED Target GOTO :Error
dsfi %Target% 0 %Size% %Source%
GOTO :EOF

:MBRWRITEI
CLS
IF NOT DEFINED Source SET /P Source=Please enter Source file: 
IF NOT EXIST %Source% ECHO File Not Found!&PAUSE&GOTO :MBRwriteI
IF NOT DEFINED Target SET /A Target=0
SET /P Target=Please enter target (drive number or file): 
FOR %%A in (0 1 2 3 4 5 6 7 8 9) DO IF %%A.==%Target%. SET /A Target=%Target%
IF %Target%==0 (
SET /P Force=You asked to overwrite MBR on \\.\PHYSICALDRIVE0, Enter YES to confirm: 
SET F
IF /I !Force!.==YES. (
SET Force=/F
) ELSE (
ECHO MBR on \\.\PHYSICALDRIVE0 was NOT overwritten!
PAUSE
GOTO :EOF
)
ECHO OFF
)
CALL :CheckMBRsize %Source% %Target% %Force%
IF NOT DEFINED Target GOTO :Error
dsfi %Target% 0 %Size% %Source%
GOTO :EOF

:CheckMBRsize
IF NOT EXIST %~dpnx1 GOTO :Error
IF %2.==. GOTO :Error
IF %~z1 NEQ 512 GOTO :Error
SET Source=%~dpnx1
SET Size=%~z1
IF /I %3.==/F. (SET MinDrive=0) ELSE (SET MinDrive=1)
IF %2 Geq %MinDrive% IF %2 Leq 9 (SET Target=\\.\PHYSICALDRIVE%2) ELSE (SET Target=%2)
set target
pause
GOTO :EOF


:MBREDIT
:parseparams
REM Needed parameters are:
REM 1) Source (and Target, they are the same) file
REM 2) Geometry= Drive Geometry, Heads/Sectors, under 2K/XP/2003 255/63, but values accepted are 255/63, 128/63, 16/63, 64/32
REM 3) PMode= Program Mode - can be either CHS or LBA
REM 4) Partnum=number of partition entry - can be 1, 2, 3 or 4
REM 5) PartType= Partition type - can be:
REM 01 FAT12
REM 04 FAT16 <32Mb (obsolete)
REM 06 FAT16 CHS mapped
REM 07 NTFS
REM 0B FAT32 CHS mapped
REM 0C FAT32 LBA mapped
REM 0E FAT16 LBA mapped
REM NO support for extended partitions of any kind!
REM 6) Active= whether the partition is Active or not - can be 0 (NOT Active) or 80 (Active)
REM
REM If Pmode=CHS following parameters are needed:
REM 7) BCyl= Beginning Cylinder
REM 8) BHd= Beginning Head
REM 9) BSec= Beginning Sector 
REM 10) ECyl= Ending Cylinder
REM 11) EHd= Ending Head
REM 12) ESec= Ending Sector
REM 13) (Optional) /S to make the batch operate silently
REM and following ones are calculated by the batch
REM 
REM If Pmode=LBA following parameters are needed:
REM 7) StartLBA= LBA address of first sector
REM 8) SectorsLBA= Number of sectors in partition
REM 9) (Optional) /S to make the batch operate silently
REM and the preceding CHS ones are calculated by the batch
REM Due to number and complexity of parameters, this batch is better suited to be
REM either called from within another batch or in interactive mode
SET OK=0
SHIFT
Set Source=%1
IF DEFINED Source IF EXIST %Source% SET /A OK+=1 
Set Geometry=%2
Set Pmode=%3
Set Partnum=%4
Set Parttype=%5
Set Active=%6
SHIFT
SHIFT
SHIFT
SHIFT
IF %Pmode%.==LBA. (
Set StartLBA=%3
Set SectorsLBA=%4
Set Silent=%5
FOR %%A IN (StartLBA SectorsLBA) DO IF NOT DEFINED %%A SET DATA=0
)
IF %Pmode%.==CHS. (
Set BCyl=%3
Set BHd=%4
Set BSec=%5
Set ECyl=%6
Set EHd=%7
Set ESec=%8
Set Silent=%9
FOR %%A IN (BCyl BHd BSec ECyl EHd ESec) DO IF NOT DEFINED %%A  SET DATA=0
)
FOR %%A IN (255/63 128/63 16/63 64/32) DO IF /I %Geometry%.==%%A. SET Geometry=%%A&SET /A OK+=10
FOR %%A IN (CHS LBA) DO IF /I %PMode%.==%%A. SET PMode=%%A&SET /A OK+=100
FOR %%A IN (1 2 3 4) DO IF %Partnum%.==%%A. SET Partnum=%%A&SET /A OK+=1000
FOR %%A IN (01 04 06 07 0B 0C 0E) DO IF /I %PartType%.==%%A. SET PartType=%%A&SET /A OK+=10000
FOR %%A IN (00 80) DO IF %Active%.==%%A. SET Active=%%A&SET /A OK+=100000
IF %OK% lss 111111 GOTO :MBREDITI
IF %DATA%.==0. GOTO :MBREDITI
GOTO :is%Pmode%

:isCHS
IF %BCyl%%BHd%%BSec% GEQ %ECyl%%EHd%%ESec% GOTO :Error
SET StartCHS=%BCyl%/%BHd%/%BSec%
SET EndCHS=%ECyl%/%EHd%/%ESec%
CALL :CHStoLBA Start %BCyl% %BHd% %BSec% %Geometry%
CALL :CHStoLBA End %ECyl% %EHd% %ESec% %Geometry%
SET /A SectorsLBA=%EndLBA%-%StartLBA%+1
GOTO :ConfirmParams

:isLBA
CALL :LBAtoCHS Start %StartLBA% %Geometry%
FOR /F "tokens=1,2,3 delims=/" %%A in ("%StartCHS%") DO SET /A BCyl=%%A&SET /A BHd=%%B&SET /A BSec=%%C
SET /A EndLBA=%StartLBA%+%SectorsLBA%-1
CALL :LBAtoCHS End %EndLBA% %Geometry%
FOR /F "tokens=1,2,3 delims=/" %%A in ("%EndCHS%") DO SET /A ECyl=%%A&SET /A EHd=%%B&SET /A ESec=%%C

:ConfirmParams
IF %BCyl% gtr 1023 SET /A BCyl=1023
IF %ECyl% gtr 1023 SET /A ECyl=1023
IF /I %Silent%.==/S. GOTO :DoSilent
ECHO Parameters are as follows:
:display
SET partline=
FOR %%A IN ( 
Partnum.6
Parttype.11
Active.16
BCyl.23
BHd.27
BSec.32
ECyl.39
EHd.43
ESec.48
StartLBA.60
SectorsLBA.74
) DO (
CALL :adddata partline %%~nA %%~xA
)
CALL :display3 NOOLD
ECHO %partline%
IF %BCyl% gtr 1023 SET /A WBCyl=1023
IF %ECyl% gtr 1023 SET /A WECyl=1023
IF DEFINED WBCyl ECHO (The Beginning Cylinder will be written as %WBCyl%)
IF DEFINED WECyl ECHO (The Ending Cylinder will be written as %WECyl%)
GOTO :DoEdit

:MBREDITI
SET partline= 
REM 1) Source (and Target, they are the same) file
IF %OK:~-1,1%==1 GOTO :SourceOK
IF NOT DEFINED SOURCE SET /P Source=Please enter Source file : 
IF NOT DEFINED Source  goto :MBREDITI
IF NOT EXIST %Source% goto :MBREDITI
:SourceOK
SET Goodparam=1
CALL :MBRVIEW DUMMY %Source%
:GeomI
REM 2) Geometry= Drive Geometry, Heads/Sectors, under 2K/XP/2003 255/63, but values accepted are 255/63, 128/63, 16/63, 64/32 
IF %OK:~-2,2%==11 GOTO :GeomOK
SET Geometry=255/63
ECHO Drive Geometry Heads/Sectors
SET /P Geometry=[255/63, 128/63, 16/63, 64/32], Enter for default [%Geometry%]:
:GeomOK
SET Range=255/63 128/63 16/63 64/32
call :checkstrings Geometry 10 11
IF NOT %Goodparam%==11 GOTO :GeomI
For /F "tokens=1,2 delims=/" %%A in ("%Geometry%") DO SET /A MaxHead=%%A-1&SET /A MaxSect=%%B

:PMI
REM 3) PMode= Program Mode - can be either CHS or LBA
IF %OK:~-3,3%==111 GOTO :PMOK
SET PMode=CHS
SET /P PMode=Program mode [CHS or LBA], Enter for default [%PMode%]:
:PMOK
SET Range=CHS LBA
call :checkstrings PMode 100 111
IF NOT %Goodparam%==111 GOTO :PMI

:PNumI
REM 4) Partnum=number of partition entry - can be 1, 2, 3 or 4
IF %OK:~-4,4%==1111 GOTO :PNumOK
SET Partnum=1
SET /P Partnum=Partition Entry [1-4], Enter for default [%partnum%]:
:PNumOK
SET Range=1 2 3 4
call :checkstrings Partnum 1000 1111 6
IF NOT %Goodparam%==1111 GOTO :PNumI

:PTI
REM 5) PartType= Partition type - can be:
REM 06 FAT16 CHS mapped
REM 07 NTFS
REM 0B FAT32 CHS mapped
REM 0C FAT32 LBA mapped
REM 0E FAT16 LBA mapped
REM NO support for extended partitions of any kind!
IF %OK:~-5,5%==11111 GOTO :PTOK
SET PartType=06
SET /P PartType=Partition type [01 04 06 07 0B 0C 0E], Enter for default [%parttype%]:
:PTOK
SET Range=01 04 06 07 0B 0C 0E
call :checkstrings Parttype 10000 11111 11
IF NOT %Goodparam%==11111 GOTO :PTI

:ActI
REM 6) Active= whether the partition is Active or not - can be 0 (NOT Active) or 80 (Active)
IF %OK:~-6,6%==111111 GOTO :ActOK
SET Active=80
SET /P Active=Active flag [00 or 80], Enter for default [%Active%]:
:ActOK
SET Range=00 80
call :checkstrings Active 100000 111111 16
IF NOT %Goodparam%==111111 GOTO :ActI
GOTO :%PMode%data

:CHSdata
REM If Pmode=CHS following parameters are needed:
REM 7) BCyl= Beginning Cylinder
SET /A Goodparam=0
IF DEFINED BCyl GOTO :BCylOK
SET /A BCyl=0
ECHO Please note that any Cylinder number greater than 1023
ECHO will be used correctly in the program, but will output 1023 anyway.
ECHO In other words if you go beyond 1023rd Cylynder, PartType must be a LBA one. 
SET /P BCyl=Beginning Cylinder [0-1023], Enter for default [%BCyl%]:
:BCylOK
call :checkvalues BCyl 1 1 23 0 100000

REM 8) BHd= Beginning Head
IF DEFINED BHd GOTO :BHdOK
SET /A BHd=1
SET /P BHd=Beginning Head [0-%MaxHead%], Enter for default [%BHd%]:
:BHdOK
call :checkvalues BHd 10 11 27 0 %MaxHead%

REM 9) BSec= Beginning Sector 
IF DEFINED BSec GOTO :BSecOK
SET /A BSec=1
SET /P BSec=Beginning Sector [1-%MaxSect%], Enter for default [%BSec%]:
:BSecOK
call :checkvalues BSec 100 111 32 1 %MaxSect%

REM 10) ECyl= Ending Cylinder
IF DEFINED ECyl GOTO :ECylOK
SET /A ECyl=%BCyl%
ECHO Please note that any Cylinder number greater than 1023
ECHO will be used correctly in the program, but will output 1023 anyway.
ECHO In other words, if you go beyond 1023rd Cylynder, PartType must be a LBA one.
SET /P ECyl=End Cylinder [%BCyl%-1023], Enter for default [%ECyl%]:
:ECylOK
call :checkvalues ECyl 1000 1111 39 %BCyl% 100000  

REM 11) EHd= Ending Head
IF DEFINED EHd GOTO :EHdOK
SET /A EHd=%MaxHead%
SET /P EHd=End Head [0-%MaxHead%], Enter for default [%EHd%]:
:EHdOK
call :checkvalues EHd 10000 11111 43 0 %MaxHead%


REM 12) ESec= Ending Sector
IF DEFINED ESec GOTO :ESecOK
SET /A ESec=%MaxSect%
SET /P ESec=End Sector [1-%MaxSect%], Enter for default [%ESec%]:
:ESecOK
call :checkvalues ESec 100000 111111 48 1 %MaxSect%

REM and following ones are calculated by the batch
CALL :CHStoLBA Start %BCyl% %BHd% %BSec% %Geometry%
CALL :CHStoLBA End %ECyl% %EHd% %ESec% %Geometry%
SET /A SectorsLBA=%EndLBA%-%StartLBA%+1
CALL :adddata partline StartLBA 60
CALL :adddata partline SectorsLBA 74
CLS&CALL :display3
ECHO %partline%
IF %BCyl% gtr 1023 SET /A WBCyl=1023
IF %ECyl% gtr 1023 SET /A WECyl=1023
IF DEFINED WBCyl ECHO (The Beginning Cylinder will be written as %WBCyl%)
IF DEFINED WECyl ECHO (The Ending Cylinder will be written as %WECyl%)
GOTO :DoEdit


:LBAdata
REM If Pmode=LBA following parameters are needed:
REM 7) StartLBA= LBA address of first sector
IF DEFINED StartLBA GOTO :StartLBAOK
SET /A StartLBA=63
SET /P StartLBA=LBA Start Address, Enter for default [%StartLBA%]:
:StartLBAOK
CALL :adddata partline StartLBA 60
CLS&CALL :display3
ECHO %partline%
REM 8) SectorsLBA= Number of sectors in partition
IF DEFINED SectorsLBA GOTO :SectorsLBAOK
SET /A SectorsLBA=0
SET /P SectorsLBA=LBA number of sectors in partition, Enter for default [%SectorsLBA%]:
:SectorsLBAOK
CALL :adddata partline SectorsLBA 74
ECHO %partline%
CLS&CALL :display3
REM and the preceding CHS ones are calculated by the batch
CALL :LBAtoCHS Start %StartLBA% %Geometry%
FOR /F "tokens=1,2,3 delims=/" %%A in ("%StartCHS%") DO SET /A BCyl=%%A&SET /A BHd=%%B&SET /A BSec=%%C
SET /A EndLBA=%StartLBA%+%SectorsLBA%-1
CALL :LBAtoCHS End %EndLBA% %Geometry%
FOR /F "tokens=1,2,3 delims=/" %%A in ("%EndCHS%") DO SET /A ECyl=%%A&SET /A EHd=%%B&SET /A ESec=%%C
SET partline=%partline:~0,17%
CALL :adddata partline BCyl 23
CALL :adddata partline BHd 27
CALL :adddata partline BSec 32
CALL :adddata partline ECyl 39
CALL :adddata partline EHd 43
CALL :adddata partline ESec 48
CALL :adddata partline StartLBA 60
CALL :adddata partline SectorsLBA 74
CLS&CALL :display3
ECHO %partline%
IF %BCyl% gtr 1023 SET /A BCyl=1023 &ECHO (The Beginning Cylinder will be written as !BCyl!)
IF %ECyl% gtr 1023 SET /A ECyl=1023 &ECHO (The Ending Cylinder will be written as !ECyl!)
REM Due to number and complexity of parameters, this batch is better suited to be
REM either called from within another batch or in interactive mode
GOTO :DoEdit

:DoEdit
ECHO Are you sure you want to write the above values to file %source%?
SET Confirm=NO
SET /P Confirm=Type YES to confirm: 
IF /I NOT %Confirm%.==YES. goto :EOF
ECHO Writing data....
:DoSilent
SET Powers=32768 16384 8192 4096 2048 1024 512 256 128 64 32 16 8 4 2 1
CALL :DEC2BIN %BCyl%
SET BCyl=%BINNUM:~-10,10%
CALL :DEC2BIN %BSec%
SET BSec=%BINNUM:~-6,6%
SET BSec=%BCyl:~0,2%%BSec%
SET BCyl=%BCyl:~-8,8%

CALL :DEC2BIN %ECyl%
SET ECyl=%BINNUM:~-10,10%
CALL :DEC2BIN %ESec%
SET ESec=%BINNUM:~-6,6%
SET ESec=%ECyl:~0,2%%ESec%
SET ECyl=%ECyl:~-8,8%
SET Powers=128 64 32 16 8 4 2 1

FOR %%A IN (BCyl BSec ECyl ESec) DO (
CALL :BIN2DEC !%%A! 8
SET %%A=!DECnum!
)

FOR %%A IN (BCyl BHd BSec ECyl EHd ESec) DO (
CALL :DEC2hex !%%A! 2
SET %%A=!HEXnum!
)
FOR %%A IN (StartLBA SectorsLBA) DO (
CALL :DEC2hex !%%A! 8
SET %%A=!HEXnum!
)
IF /I NOT %Silent%.==/S. FOR %%A IN ( PartType Active BCyl BHd BSec ECyl EHd ESec StartLBA SectorsLBA) DO SET %%A
SET DataString=$%Active%$%BHd%$%BSec%$%BCyl%$%PartType%$%EHd%$%ESec%$%ECyl%$%StartLBA:~0,2%$%StartLBA:~2,2%$%StartLBA:~4,2%$%StartLBA:~6,2%$%SectorsLBA:~0,2%$%SectorsLBA:~2,2%$%SectorsLBA:~4,2%$%SectorsLBA:~6,2%

REM Partition Data offset: 1=446 2=462 3=478 4=494
Set /A Offset=430+%Partnum%*16
Set /A Length=16

if "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto echooox64bypass
if not exist echoo.com (
echo Bj@jzh`0X-`/PPPPPPa(DE(DM(DO(Dh(Ls(Lu(LX(LeZRR]EEEUYRX2Dx=
echo 0DxFP,0Xx.t0P,=XtGsB4o@$?PIyU WwX0GwUY Wv;ovBX2Gv0ExGIuht6
echo ?@xAyJHmH@=a?}VjuN?_LEkS?`w`s_{OCIvJDGEHtc{OCIKGMgELCI?GGg
echo EL?s?WL`LRBcx=k_K?AxVD?fCo?Cd?BLDs0
)>>echoo.com 
echoo.com %DataString% >TMPDATA.$$$
goto echooobpatbypass
:echooox64bypass
echo 0123456789ABCD>TMPDATA.$$$
bpatcher.exe TMPDATA.$$$ 00 %Active%
bpatcher.exe TMPDATA.$$$ 01 %BHd%
bpatcher.exe TMPDATA.$$$ 02 %BSec%
bpatcher.exe TMPDATA.$$$ 03 %BCyl%
bpatcher.exe TMPDATA.$$$ 04 %Parttype%
bpatcher.exe TMPDATA.$$$ 05 %EHd%
bpatcher.exe TMPDATA.$$$ 06 %ESec%
bpatcher.exe TMPDATA.$$$ 07 %ECyl%
bpatcher.exe TMPDATA.$$$ 08 %StartLBA:~0,2%
bpatcher.exe TMPDATA.$$$ 09 %StartLBA:~2,2%
bpatcher.exe TMPDATA.$$$ 0A %StartLBA:~4,2%
bpatcher.exe TMPDATA.$$$ 0B %StartLBA:~6,2%
bpatcher.exe TMPDATA.$$$ 0C %SectorsLBA:~0,2%
bpatcher.exe TMPDATA.$$$ 0D %SectorsLBA:~2,2%
bpatcher.exe TMPDATA.$$$ 0E %SectorsLBA:~4,2%
bpatcher.exe TMPDATA.$$$ 0F %SectorsLBA:~6,2%
:echooobpatbypass
dsfi %source% %Offset% %Length% TMPDATA.$$$>nul
GOTO :EOF

:LBAtoCHS
REM %1 is Variable name
REM %2 is the LBA value to convert
REM %3 is the disk geometry like 255/63
REM To get CHS from LBA:
REM CYL = LBA / (THds * TSec)
REM TEMPVAL = LBA % (THds * TSec)
REM HEAD = TEMP / TSec
REM SECT = TEMP % TSec + 1
REM Where:
REM LBA: linear base address of the block
REM CYL: value of the cylinder CHS coordinate
REM THds: Total number of heads per cylinder for the disk
REM HEAD: value of the head CHS coordinate
REM TSec: Total number of sectors per head for the disk
REM SECT: value of the sector CHS coordinate
REM TEMPVAL: buffer to hold a temporary value
SET /A LBA=%2
FOR /F "tokens=1,2 delims=/" %%A in ("%3") DO SET THds=%%A&SET TSec=%%B
SET /A TEMPVAL = THds * TSec
SET /A CYL = LBA/TEMPVAL
SET /A TEMPVAL = "%LBA% %% %TEMPVAL%"
SET /A HEAD = TEMPVAL/TSec
SET /A SECT = "%TEMPVAL% %% %TSec% + 1"
SET %1CHS=%CYL%/%HEAD%/%SECT%
GOTO :EOF

:CHStoLBA
REM %1 is Variable name
REM %2 is the C value to convert
REM %3 is the H value to convert
REM %4 is the S value to convert
REM %5 is the disk geometry like 255/63
REM To get LBA from CHS values:
REM LBA = ( ( CYL * Thds + HEAD ) * Tsec ) + SECT - 1
REM Where:
REM LBA: linear base address of the block
REM CYL: value of the cylinder CHS coordinate
REM THds: Total number of heads per cylinder for the disk
REM HEAD: value of the head CHS coordinate
REM TSec: Total number of sectors per head for the disk
REM SECT: value of the sector CHS coordinate
FOR /F "tokens=1,2 delims=/" %%A in ("%5") DO SET THds=%%A&SET TSec=%%B
SET CYL=%2
SET HEAD=%3
SET SECT=%4
Set /a %1LBA = "(CYL * THds + HEAD) * TSec + SECT - 1"
GOTO :EOF

:checklength
SET /A Counter=0
SET data=!%1!
:LoopLength
SET /A Counter=%Counter%+1
IF NOT "%data%"=="!data:~0,%Counter%!" GOTO :LoopLength
SET /A %1Length=Counter
GOTO :EOF

:Padzeroes
SET /A sCounter=%sCounter%+1
SET String=%String%$00
IF NOT %sCounter%==%1 goto :Padzeroes
IF %2.==MagSig. SET String=%String%$55$AA
ECHoo.com %String%>> test.mbr
GOTO :EOF

:checkstrings
REM Parameters are:
REM Variable Goodnumber Goodvalue Sep_offset
FOR %%A IN (%Range%) DO IF /I !%1!.==%%A. SET /A Goodparam=%Goodparam%+%2
IF NOT %Goodparam%==%3 GOTO :EOF
CALL :adddata partline %1 %4
CLS&CALL :display3
ECHO %partline%
GOTO :EOF

:checkvalues
REM Parameters are:
REM Variable Goodnumber Goodvalue Sep_offset min max 
IF !%1! Geq %5 IF !%1! Leq %6 SET /A Goodparam=%Goodparam%+%2
IF NOT %Goodparam%==%3 GOTO :EOF
CALL :adddata partline %1 %4
CLS&CALL :display3
ECHO %partline%
GOTO :EOF

:display3
IF %1.==NOOLD. goto :NOOLD
For %%A IN (a b c d e 1 f 2 f 3 f 4 g) DO ECHO !Line%%A!
:NOOLD
ECHO.
ECHO Drive geometry: %Geometry% Program Mode: %PMode%
ECHO Ŀ
ECHO Part TypeBoot  Begin   CHS     End   CHS    LBA Start  LBA Sectors 
ECHO   #           BCyl BHdBSec ECyl EHdESec                        
ECHO Ĵ
GOTO :EOF

:adddata
if %3.==. GOTO :EOF
set templine=%1
set thisline=!%templine%!
set pad=%2
set pad=!%pad%!
set sepoffset=%3
set sepoffset=%sepoffset:.=%
:dataloop
SET templine=%thisline%%pad%
set pad= %pad%
IF NOT "!templine:~%sepoffset%,1!"=="" goto :dataloop
SET %1=%templine%
GOTO :EOF

:MBRHELP
SET HELP=%2
IF NOT DEFINED HELP SET HELP=ALL&CALL :MBRHELPI
ECHO %1 %2
PAUSE
SET /A comline=0
FOR %%A IN (CREATE VIEW COPY EDIT UPATCH WRITE HELP ALL) DO IF /I %%A.==%HELP%. SET /A comline=!comline!+1
IF NOT %comline%==1 GOTO :ERROR
GOTO :MBRHELP%HELP%

:MBRHELPI
CLS
ECHO Input the command you need help on or press [ENTER] to view ALL commands help:
ECHO Available commands: CREATE VIEW COPY EDIT UPATCH WRITE HELP
SET HELP
SET /P HELP=
GOTO :EOF

:MBRHELPALL
FOR %%A IN (CREATE VIEW COPY EDIT UPATCH WRITE HELP) DO CALL :MBRHELP%%A
GOTO :EOF

:MBRHELPCREATE
CLS
ECHO %~nx0 CREATE   targetfile	Creates a MBR from a System file
ECHO						and saves it to destfile
ECHO.
ECHO A copy of the MBR is embedded inside a few system files:
ECHO - %SystemRoot%\System32\dmadmin.exe
ECHO - %SystemRoot%\System32\spcmdcon.sys
ECHO - %SystemRoot%\ServicePackFiles\I386\setupdd.sys
ECHO.
ECHO %~nx0 uses by default dmadmin.exe
ECHO If you are using a "lited" 2K/XP where this file has been removed
ECHO edit the batch accordingly, if you use the batch on just one system
ECHO you may also set a fixed offset and avoid the need for gsar.exe
ECHO.
ECHO The setting is at the beginning of the :MBRCREATE label in %~nx0
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLE:
ECHO %~nx0 CREATE C:\MBRBATCHDIR\my_MBR.mbr
PAUSE
GOTO :EOF

:MBRHELPVIEW
CLS
ECHO %~nx0 VIEW   [source]		Shows partition entries in source MBR
ECHO.
ECHO Source can be either a MBR file or a drive number.
ECHO.
ECHO Drive numbers begin with 0.
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 VIEW C:\MBRBATCHDIR\my_MBR.mbr
ECHO %~nx0 VIEW 0
PAUSE
GOTO :EOF

:MBRHELPCOPY
CLS
ECHO COPY  [source] [destfile] 	Creates a MBR from source 
ECHO					and saves it to a file
ECHO.
ECHO Source can be either a MBR file or a drive number.
ECHO What the command does is to simply extract first 512
ECHO bytes from [source], so it can also be any file in 
ECHO which the first 512 bytes are a Master Boot Record.
ECHO.
ECHO Drive numbers begin with 0.
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 COPY C:\MBRBATCHDIR\my_MBR.mbr C:\ANOTHERDIR\SomeMBR.bin
ECHO %~nx0 COPY 0 my_MBR.mbr
PAUSE
GOTO :EOF

:MBRHELPEDIT
CLS
ECHO EDIT   [source] [MBRparams]	Edits one partition entry in MBR file
ECHO.
ECHO Source can be ONLY a MBR file (CREATEd or COPYed).
ECHO.
ECHO [MBRparams] are a bit complex:
ECHO Geometry Part PartType Active PMode [More_parameters]
ECHO.
ECHO Geometry = Drive Geometry, Heads/Sectors, under 2K/XP/2003 255/63,
ECHO            but values accepted are 255/63, 128/63, 16/63, 
ECHO.
ECHO Part     = number of partition entry - can be 1, 2, 3 or 4
ECHO.
ECHO PartType = Partition type - can be:
ECHO		01 FAT12
ECHO		04 FAT16 <32 Mb (obsolete)
ECHO 		06 FAT16 CHS mapped 
ECHO 		07 NTFS             
ECHO 		0B FAT32 CHS mapped  NO support for extended partitions
ECHO 		0C FAT32 LBA mapped 
ECHO 		0E FAT16 LBA mapped 
ECHO.
ECHO Active =   Active flag for entry - can be 0 (NOT Active) or 80 (Active)
ECHO.
ECHO PMode  =   Program Mode - can be either CHS or LBA
ECHO.
PAUSE
CLS
ECHO PMode  =   Program Mode - can be either CHS or LBA
ECHO.
ECHO If Pmode = CHS, six more parameters are needed:
ECHO.
ECHO CHANGE [source] Geometry Part PartType Active CHS BCyl BHd BSec ECyl EHd ESec
ECHO.
ECHO BCyl = Beginning Cylinder
ECHO BHd  = Beginning Head
ECHO BSec = Beginning Sector 
ECHO ECyl = Ending Cylinder
ECHO EHd  = Ending Head
ECHO ESec = Ending Sector
ECHO.
ECHO If Pmode = LBA, only two more parameters are needed:
ECHO.
ECHO CHANGE [source] Geometry Part PartType Active LBA StartLBA SectorsLBA
ECHO.
ECHO StartLBA   = LBA address of first sector
ECHO SectorsLBA = Number of sectors in partition
ECHO.
ECHO The batch in CHS mode will calculate LBA values, whilst in LBA mode it
ECHO will calculate CHS ones.
ECHO.
PAUSE
CLS
REM and the preceding CHS ones are calculated by the batch
ECHO Due to number and complexity of parameters, this batch is better suited to be
ECHO either called from within another batch or in interactive mode.
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 CHANGE my_MBR.mbr 255/63 1 0B 80 CHS 0 1 1 127 254 63
ECHO %~nx0 CHANGE my_MBR.mbr 255/63 1 0B 80 LBA 63 2056257
PAUSE
GOTO :EOF

:MBRHELPUPATCH
CLS
ECHO UPATCH [source]		Patches MBR with "HP" USB/int13 modification
ECHO 				(MBR MUST be a Win2K/XP/2003 one)
ECHO.
ECHO Simply changes the MBR code of source file to skip Extended INT13h
ECHO checks, exactly as the DataSystem/HP utility does.
ECHO This is only worth a try if you are managing a MBR on a USB Mass Storage
ECHO Device, be it an external hard disk or Flash memory device, and only if
ECHO the drive does not boot on a certain type of motherboard with the normal
ECHO MBR, i.e. the one you can CREATE with this batch. 
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 UPATCH C:\A_directory\my_MBR.mbr
PAUSE
GOTO :EOF

:MBRHELPWRITE
CLS
ECHO %~nx0 WRITE [source] [destdrive] [/F] Writes a MBR file to destdrive
ECHO.
ECHO Simply writes the MBR code of source file to destdrive.
ECHO For security reasons, if you input first disk, i.e. 0, you NEED to add
ECHO the parameter /F (for FORCE) when %~nx0 is invoked from command line or
ECHO from amother batch.
ECHO In interactive mode, a confirmation will be asked anyway.
ECHO.
ECHO Please use some common sense for filenames:
ECHO NO spaces in name, extension or path, the batch has been tested
ECHO ONLY with "pure" DOS 8.3 names
ECHO.
ECHO EXAMPLES:
ECHO %~nx0 WRITE C:\A_directory\my_MBR.mbr 1
ECHO will write contents of file my_MBR.mbr (512 bytes) to \\.\PHYSICALDRIVE1
ECHO %~nx0 WRITE C:\A_directory\my_MBR.mbr 0 /F
ECHO will write contents of file my_MBR.mbr (512 bytes) to \\.\PHYSICALDRIVE0
PAUSE
GOTO :EOF

:MBRHELPHELP
CLS
ECHO %~nx0 HELP		Shows the HELP info
ECHO.
ECHO Basically, if you need help to use the HELP command,
ECHO I am afraid you won't be able to appreciate the use
ECHO of this batch file. :(
ECHO.
ECHO Try the HELP command with some other command, it might
ECHO be more useful than this lame notice. ;)
PAUSE
GOTO :EOF

:error
ECHO An error has occurred
GOTO :EOF

:error1
ECHO Please add the missing file in the same directory where %~nx0 is
GOTO :EOF

:Temporary_Code
if not exist echoo.com (
echo Bj@jzh`0X-`/PPPPPPa(DE(DM(DO(Dh(Ls(Lu(LX(LeZRR]EEEUYRX2Dx=
echo 0DxFP,0Xx.t0P,=XtGsB4o@$?PIyU WwX0GwUY Wv;ovBX2Gv0ExGIuht6
echo ?@xAyJHmH@=a?}VjuN?_LEkS?`w`s_{OCIvJDGEHtc{OCIKGMgELCI?GGg
echo EL?s?WL`LRBcx=k_K?AxVD?fCo?Cd?BLDs0
)>>echoo.com 

Set /A Length=512
SET /A sCOUNTER=0
SET /A BCOUNTER=0
SET String=
FOR /F "tokens=2 delims=: " %%A IN ('dumphex /s%Offset% /L%Length% /w1 /nc %SystemRoot%\System32\dmadmin.exe') DO (
SET /A sCOUNTER=!sCOUNTER!+1
SET String=!String!$%%A
IF !sCOUNTER!==32 (
ECHoo.com !String!>> %2
SET sCOUNTER=0
SET /A BCOUNTER=!BCOUNTER!+1
SET STRING=
)
IF !BCOUNTER!==13 IF !sCOUNTER!==30 GOTO :PartData
)

:PartData
SET Active=80
SET PartType=0E
SET EHd=0F
SET ESec=3F
SET ECyl=24
SET SecBef=3F000000
SET TotSec=71910000
SET String=%String%$%Active%$01
ECHoo.com !String!>> test.mbr
SET String=$01$00$%PartType%$%EHd%$%ESec%$%ECyl%$%SecBef:~0,2%$%SecBef:~2,2%$%SecBef:~4,2%$%SecBef:~6,2%$%TotSec:~0,2%$%TotSec:~2,2%$%TotSec:~4,2%$%TotSec:~6,2%
SET /A sCounter=14
CALL :Padzeroes 32
SET /A sCounter=0
SET String=
CALL :Padzeroes 30 MagSig
GOTO :EOF